unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, VCLTee.Series, TeCanvas, Math;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    procedure Chart1AfterDraw(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TLineSeriesLCB = class(TLineSeries)
  public
    LegendCheckBox: boolean;
    LegendPos: TPoint;
  end;

const diff=25;

procedure TForm1.Chart1AfterDraw(Sender: TObject);
var i, maxWidth, tmpX, tmpY, tmpH: Integer;
const xoff = 4;
      yoff = 2;
      ypos = 10;
      cbSize=12;
begin
  maxWidth:=0;

  with Chart1.Canvas do
  begin
    AssignBrush(Chart1.Legend.Brush);
    AssignVisiblePen(Chart1.Legend.Pen);
    AssignFont(Chart1.Legend.Font);
  end;

  for i:=0 to Chart1.SeriesCount-1 do
    maxWidth:=Max(maxWidth, Chart1.Canvas.TextWidth(SeriesTitleOrName(Chart1[i])));

  tmpX:=Chart1.Width-maxWidth-cbSize*2-xoff*4-10;

  with Chart1.Canvas do
  begin
    tmpH:=TextHeight(SeriesTitleOrName(Chart1[0]));
    Rectangle(tmpX, ypos, tmpX+cbSize*2+xoff*4+maxWidth, tmpH*Chart1.SeriesCount+ypos+yoff*2);

    for i:=0 to Chart1.SeriesCount-1 do
    begin
      with TLineSeriesLCB(Chart1[i]) do
        if LegendCheckBox then
        begin
          LegendPos.X:=tmpX+xoff;
          LegendPos.Y:=ypos+tmpH*i+4;
          DrawCheckBox(LegendPos.X, LegendPos.Y, Chart1[i].Active, Chart1.Legend.Color);
        end;

      AssignBrush(Chart1[i].Brush);
      Brush.Color:=Chart1[i].Color;
      Rectangle(tmpX+cbSize+xoff*2+2, ypos+tmpH*i+4, tmpX+cbSize+xoff*2+12, ypos+tmpH*i+14);
      TextOut(tmpX+cbSize*2+xoff*3, ypos+tmpH*i, SeriesTitleOrName(Chart1[i]));
    end;
  end;
end;

procedure TForm1.Chart1Click(Sender: TObject);
var i: Integer;
begin
  for i:=0 to Chart1.SeriesCount-1 do
  begin
    with TLineSeriesLCB(Chart1[i]) do
      if PointInRect(Rect(LegendPos, Point(LegendPos.X+12, LegendPos.Y+12)), Chart1.GetCursorPos) then
      begin
         Active:=not Active;
         Chart1.Draw;
      end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  Chart1.Legend.Hide;

  for i:=0 to 4 do
    with TLineSeriesLCB(Chart1.AddSeries(TLineSeriesLCB)) do
    begin
      LegendCheckBox:=i mod 2=0;
      FillSampleValues;
    end;
end;

end.
